unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, IdBaseComponent, IdThreadComponent;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel1: TPanel;
    Image1: TImage;
    Shape1: TShape;
    Shape2: TShape;
    Label3: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;

    
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Proc: procedure;
  x1,x2,y1,y2,ddx,ddy:Double;
implementation

uses Math;

{$R *.dfm}

procedure DrawLine8Connected(x1 : Double;
     y1 : Double;
     x2 : Double;
     y2 : Double);
var
    x : Double;
    y : Double;
    dx : Double;
    dy : Double;
    sx : Double;
    sy : Double;
    z : Double;
    e : Double;
    i : Double;
    Ch : Boolean;
begin
    x := x1;
    y := y1;
    dx := Abs(x2-x1);
    dy := Abs(y2-y1);
    sx := Sign(x2-x1);
    sy := Sign(y2-y1);
    if (dx=0) and (dy=0) then
    begin
        Form1.Image1.Canvas.Pixels[Round(x1*ddx)+250, Round(y1*ddy)+150]:=RGB(1,1,1);
        Exit;
    end;
    if dy>dx then
    begin
        z := dx;
        dx := dy;
        dy := z;
        ch := True;
    end
    else
    begin
        ch := False;
    end;
    e := 2*dy-dx;
    i := 1;
    repeat
        Form1.Image1.Canvas.Pixels[Round(x*ddx)+250, Round(y*ddy)+150]:=RGB(1,1,1);
        while e>=0 do
        begin
            if ch then
            begin
                x := x+sx;
            end
            else
            begin
                y := y+sy;
            end;
            e := e-2*dx;
        end;
        if ch then
        begin
            y := y+sy;
        end
        else
        begin
            x := x+sx;
        end;
        e := e+2*dy;
        i := i+1;
    until i>dx;
    Form1.Image1.Canvas.Pixels[Round(x*ddx)+250, Round(y*ddy)+150]:=RGB(1,1,1);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
xx1,xx2,yy1,yy2:Double;
begin
x1:=StrToFloat(Edit1.Text);
x2:=StrToFloat(Edit3.Text);
y1:=StrToFloat(Edit2.Text);
y2:=StrToFloat(Edit4.Text);
ddx:=StrToFloat(Edit5.Text);
ddy:=StrToFloat(Edit6.Text);
xx1:=x1/ddx;
xx2:=x2/ddx;
yy1:=y1/ddy;
yy2:=y2/ddy;

DrawLine8Connected(Round(xx1) , Round(yy1) ,Round(xx2) , Round(yy2) );
end;

end.
